scala.tools.nsc.transform.patmat.MatchApproximation.MatchApproximator.TreeMakersToProps

# TreeMakerToProp

#### abstract class TreeMakerToProp extends (MatchApproximator.TreeMaker) ⇒ MatchApproximator.Prop

Source
  MatchAnalysis.scala

Linear Supertypes
(MatchApproximator.TreeMaker) ⇒ MatchApproximator.Prop, AnyRef, Any
Known Subclasses
conservative
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. TreeMakerToProp
2. Function1
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new TreeMakerToProp()

### Abstract Value Members

1. #### abstract def handleUnknown(tm: MatchApproximator.TreeMaker): MatchApproximator.Prop

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from TreeMakerToProp to any2stringadd[TreeMakerToProp] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (TreeMakerToProp, B)

   Implicit information
     This member is added by an implicit conversion from TreeMakerToProp to ArrowAssoc[TreeMakerToProp] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### def andThen[A](g: (MatchApproximator.Prop) ⇒ A): (MatchApproximator.TreeMaker) ⇒ A

   Definition Classes
     Function1
   Annotations
     @unspecialized()

7. #### def apply(tm: MatchApproximator.TreeMaker): MatchApproximator.Prop

   apply itself must render a faithful representation of the TreeMaker

   apply itself must render a faithful representation of the TreeMaker

   Concretely, True must only be used to represent a TreeMaker that is sure to match and that does not do any computation at all e.g., doCSE relies on apply itself being sound in this sense (since it drops TreeMakers that are approximated to True -- SI-6077)

   handleUnknown may be customized by the caller to approximate further

   TODO: don't ignore outer-checks

   Definition Classes
     TreeMakerToProp → Function1

8. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

9. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

10. #### def compose[A](g: (A) ⇒ MatchApproximator.TreeMaker): (A) ⇒ MatchApproximator.Prop

    Definition Classes
      Function1
    Annotations
      @unspecialized()

11. #### def ensuring(cond: (TreeMakerToProp) ⇒ Boolean, msg: ⇒ Any): TreeMakerToProp

    Implicit information
      This member is added by an implicit conversion from TreeMakerToProp to Ensuring[TreeMakerToProp] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: (TreeMakerToProp) ⇒ Boolean): TreeMakerToProp

    Implicit information
      This member is added by an implicit conversion from TreeMakerToProp to Ensuring[TreeMakerToProp] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: Boolean, msg: ⇒ Any): TreeMakerToProp

    Implicit information
      This member is added by an implicit conversion from TreeMakerToProp to Ensuring[TreeMakerToProp] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: Boolean): TreeMakerToProp

    Implicit information
      This member is added by an implicit conversion from TreeMakerToProp to Ensuring[TreeMakerToProp] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

16. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

17. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

18. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from TreeMakerToProp to StringFormat[TreeMakerToProp] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

19. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

20. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

21. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

22. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

23. #### final def notify(): Unit

    Definition Classes
      AnyRef

24. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

25. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

26. #### def toString(): String

    Definition Classes
      Function1 → AnyRef → Any

27. #### def updateSubstitution(subst: MatchApproximator.Substitution): Unit

28. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

29. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

30. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

31. #### def →[B](y: B): (TreeMakerToProp, B)

    Implicit information
      This member is added by an implicit conversion from TreeMakerToProp to ArrowAssoc[TreeMakerToProp] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from (MatchApproximator.TreeMaker) ⇒ MatchApproximator.Prop

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from TreeMakerToProp to any2stringadd[TreeMakerToProp]

### Inherited by implicit conversion StringFormat from TreeMakerToProp to StringFormat[TreeMakerToProp]

### Inherited by implicit conversion Ensuring from TreeMakerToProp to Ensuring[TreeMakerToProp]

### Inherited by implicit conversion ArrowAssoc from TreeMakerToProp to ArrowAssoc[TreeMakerToProp]

### Ungrouped